#ifndef AdjudicatorSAN_H_
#define AdjudicatorSAN_H_

#include "Cpp/BaseClasses/EmptyGroup.h"
#include "Cpp/BaseClasses/PreselectGroup.h"
#include "Cpp/BaseClasses/PostselectGroup.h"
#include "Cpp/BaseClasses/state/StructStateVariable.h"
#include "Cpp/BaseClasses/state/ArrayStateVariable.h"
#include "Cpp/BaseClasses/SAN/SANModel.h" 
#include "Cpp/BaseClasses/SAN/Place.h"
#include "Cpp/BaseClasses/SAN/ExtendedPlace.h"
extern double CC_failure_rate;
extern short CC_enabler;
extern UserDistributions* TheDistribution;

void MemoryError();


/*********************************************************************
               AdjudicatorSAN Submodel Definition                   
*********************************************************************/

class AdjudicatorSAN:public SANModel{
public:

class System_OK_ActActivity:public Activity {
public:

  Place* CH1_OK;
  short* CH1_OK_Mobius_Mark;
  Place* CH2_OK;
  short* CH2_OK_Mobius_Mark;
  Place* System_OK;
  short* System_OK_Mobius_Mark;
  Place* System_Safe_Failure;
  short* System_Safe_Failure_Mobius_Mark;
  Place* System_Unsafe_State;
  short* System_Unsafe_State_Mobius_Mark;

  double* TheDistributionParameters;
  System_OK_ActActivity();
  double Rate(){return 0;}
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
}; // System_OK_ActActivityActivity

class System_SS_ActActivity:public Activity {
public:

  Place* CH1_OK;
  short* CH1_OK_Mobius_Mark;
  Place* CH2_OK;
  short* CH2_OK_Mobius_Mark;
  Place* System_Safe_Failure;
  short* System_Safe_Failure_Mobius_Mark;
  Place* CH1_Safe_Failure;
  short* CH1_Safe_Failure_Mobius_Mark;
  Place* CH2_Safe_Failure;
  short* CH2_Safe_Failure_Mobius_Mark;
  Place* System_OK;
  short* System_OK_Mobius_Mark;
  Place* System_Unsafe_State;
  short* System_Unsafe_State_Mobius_Mark;

  double* TheDistributionParameters;
  System_SS_ActActivity();
  double Rate(){return 0;}
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
}; // System_SS_ActActivityActivity

class System_US_ActActivity:public Activity {
public:

  Place* CH1_OK;
  short* CH1_OK_Mobius_Mark;
  Place* CH2_OK;
  short* CH2_OK_Mobius_Mark;
  Place* CH1_Safe_Failure;
  short* CH1_Safe_Failure_Mobius_Mark;
  Place* CH2_Safe_Failure;
  short* CH2_Safe_Failure_Mobius_Mark;
  Place* System_Unsafe_State;
  short* System_Unsafe_State_Mobius_Mark;
  Place* System_OK;
  short* System_OK_Mobius_Mark;
  Place* System_Safe_Failure;
  short* System_Safe_Failure_Mobius_Mark;

  double* TheDistributionParameters;
  System_US_ActActivity();
  double Rate(){return 0;}
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
}; // System_US_ActActivityActivity

class Common_failureActivity:public Activity {
public:

  Place* CH1_OK;
  short* CH1_OK_Mobius_Mark;
  Place* CH2_OK;
  short* CH2_OK_Mobius_Mark;
  Place* System_OK;
  short* System_OK_Mobius_Mark;
  Place* CCF_enabler;
  short* CCF_enabler_Mobius_Mark;
  Place* CCF_active;
  short* CCF_active_Mobius_Mark;

  double* TheDistributionParameters;
  Common_failureActivity();
  ~Common_failureActivity();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // Common_failureActivityActivity

  //List of user-specified place names
  Place* CH1_OK;
  Place* CH2_OK;
  Place* CH1_Safe_Failure;
  Place* CH1_US_Failure;
  Place* CH2_Safe_Failure;
  Place* CH2_US_Failure;
  Place* System_OK;
  Place* System_Safe_Failure;
  Place* System_Unsafe_State;
  Place* CCF_active;
  Place* CCF_enabler;

  // Create instances of all actvities
  System_OK_ActActivity System_OK_Act;
  System_SS_ActActivity System_SS_Act;
  System_US_ActActivity System_US_Act;
  Common_failureActivity Common_failure;
  //Create instances of all groups 
  PreselectGroup ImmediateGroup;
  PostselectGroup System_OK_ActGroup;
  PostselectGroup System_SS_ActGroup;
  PostselectGroup System_US_ActGroup;

  AdjudicatorSAN();
  ~AdjudicatorSAN();
  void CustomInitialization();

  void assignPlacesToActivitiesInst();
  void assignPlacesToActivitiesTimed();
}; // end AdjudicatorSAN

#endif // AdjudicatorSAN_H_
