

// This C++ file was created by SanEditor

#include "Atomic/Adversary/AdversarySAN.h"

#include <stdlib.h>
#include <iostream>

#include <math.h>


/*****************************************************************
                         AdversarySAN Constructor             
******************************************************************/


AdversarySAN::AdversarySAN(){


  Attacker_ProfileGroup.initialize(3, "Attacker_ProfileGroup");
  Attacker_ProfileGroup.appendGroup((BaseGroupClass*) &Attacker_Profile_case1);
  Attacker_ProfileGroup.appendGroup((BaseGroupClass*) &Attacker_Profile_case2);
  Attacker_ProfileGroup.appendGroup((BaseGroupClass*) &Attacker_Profile_case3);

  SW_CH_SelectGroup.initialize(2, "SW_CH_SelectGroup");
  SW_CH_SelectGroup.appendGroup((BaseGroupClass*) &SW_CH_Select_case1);
  SW_CH_SelectGroup.appendGroup((BaseGroupClass*) &SW_CH_Select_case2);

  C_CH_SelectGroup.initialize(2, "C_CH_SelectGroup");
  C_CH_SelectGroup.appendGroup((BaseGroupClass*) &C_CH_Select_case1);
  C_CH_SelectGroup.appendGroup((BaseGroupClass*) &C_CH_Select_case2);

  Activity* InitialActionList[9]={
    &SW_CH_Select_case1, //0
    &SW_CH_Select_case2, //1
    &C_CH_Select_case1, //2
    &C_CH_Select_case2, //3
    &Both_SS_conf_attacked, //4
    &Both_Control_Conf_attacked, //5
    &Attacker_Profile_case1, //6
    &Attacker_Profile_case2, //7
    &Attacker_Profile_case3  // 8
  };

  BaseGroupClass* InitialGroupList[5]={
    (BaseGroupClass*) &(Attacker_ProfileGroup), 
    (BaseGroupClass*) &(SW_CH_SelectGroup), 
    (BaseGroupClass*) &(C_CH_SelectGroup), 
    (BaseGroupClass*) &(Both_SS_conf_attacked), 
    (BaseGroupClass*) &(Both_Control_Conf_attacked)
  };

  Start = new Place("Start" ,attack_count);
  Channel1_attacked = new Place("Channel1_attacked" ,0);
  Channel2_attacked = new Place("Channel2_attacked" ,0);
  AttackedID_1 = new Place("AttackedID_1" ,0);
  AttackedID_2 = new Place("AttackedID_2" ,0);
  ConfAttack_in_progress = new Place("ConfAttack_in_progress" ,0);
  Torque_Attack_in_progress = new Place("Torque_Attack_in_progress" ,0);
  ControlAttack_in_progress = new Place("ControlAttack_in_progress" ,0);
  C_CH_1_attacked = new Place("C_CH_1_attacked" ,0);
  C_CH_2_attacked = new Place("C_CH_2_attacked" ,0);
  single_both_enabler = new Place("single_both_enabler" ,single_SS_enabler_is_0);
  BaseStateVariableClass* InitialPlaces[11]={
    Start,  // 0
    Channel1_attacked,  // 1
    Channel2_attacked,  // 2
    AttackedID_1,  // 3
    AttackedID_2,  // 4
    ConfAttack_in_progress,  // 5
    Torque_Attack_in_progress,  // 6
    ControlAttack_in_progress,  // 7
    C_CH_1_attacked,  // 8
    C_CH_2_attacked,  // 9
    single_both_enabler   // 10
  };
  BaseStateVariableClass* InitialROPlaces[0]={
  };
  initializeSANModelNow("Adversary", 11, InitialPlaces, 
                        0, InitialROPlaces, 
                        9, InitialActionList, 5, InitialGroupList);


  assignPlacesToActivitiesInst();
  assignPlacesToActivitiesTimed();

  int AffectArcs[24][2]={ 
    {5,0}, {1,0}, {3,0}, {5,1}, {2,1}, {4,1}, {7,2}, {8,2}, {7,3}, 
    {9,3}, {5,4}, {3,4}, {1,4}, {4,4}, {2,4}, {7,5}, {8,5}, {9,5}, 
    {0,6}, {5,6}, {0,7}, {6,7}, {0,8}, {7,8}
  };
  for(int n=0;n<24;n++) {
    AddAffectArc(InitialPlaces[AffectArcs[n][0]],
                 InitialActionList[AffectArcs[n][1]]);
  }
  int EnableArcs[15][2]={ 
    {5,0}, {10,0}, {5,1}, {10,1}, {7,2}, {10,2}, {7,3}, {10,3}, 
    {5,4}, {10,4}, {7,5}, {10,5}, {0,6}, {0,7}, {0,8}
  };
  for(int n=0;n<15;n++) {
    AddEnableArc(InitialPlaces[EnableArcs[n][0]],
                 InitialActionList[EnableArcs[n][1]]);
  }

  for(int n=0;n<9;n++) {
    InitialActionList[n]->LinkVariables();
  }
  CustomInitialization();

}

void AdversarySAN::CustomInitialization() {

}
AdversarySAN::~AdversarySAN(){
  for (int i = 0; i < NumStateVariables-NumReadOnlyPlaces; i++)
    delete LocalStateVariables[i];
};

void AdversarySAN::assignPlacesToActivitiesInst(){
  SW_CH_Select_case1.ConfAttack_in_progress = (Place*) LocalStateVariables[5];
  SW_CH_Select_case1.single_both_enabler = (Place*) LocalStateVariables[10];
  SW_CH_Select_case1.Channel1_attacked = (Place*) LocalStateVariables[1];
  SW_CH_Select_case1.AttackedID_1 = (Place*) LocalStateVariables[3];
  SW_CH_Select_case2.ConfAttack_in_progress = (Place*) LocalStateVariables[5];
  SW_CH_Select_case2.single_both_enabler = (Place*) LocalStateVariables[10];
  SW_CH_Select_case2.Channel2_attacked = (Place*) LocalStateVariables[2];
  SW_CH_Select_case2.AttackedID_2 = (Place*) LocalStateVariables[4];
  C_CH_Select_case1.ControlAttack_in_progress = (Place*) LocalStateVariables[7];
  C_CH_Select_case1.single_both_enabler = (Place*) LocalStateVariables[10];
  C_CH_Select_case1.C_CH_1_attacked = (Place*) LocalStateVariables[8];
  C_CH_Select_case2.ControlAttack_in_progress = (Place*) LocalStateVariables[7];
  C_CH_Select_case2.single_both_enabler = (Place*) LocalStateVariables[10];
  C_CH_Select_case2.C_CH_2_attacked = (Place*) LocalStateVariables[9];
  Both_SS_conf_attacked.ConfAttack_in_progress = (Place*) LocalStateVariables[5];
  Both_SS_conf_attacked.single_both_enabler = (Place*) LocalStateVariables[10];
  Both_SS_conf_attacked.AttackedID_1 = (Place*) LocalStateVariables[3];
  Both_SS_conf_attacked.Channel1_attacked = (Place*) LocalStateVariables[1];
  Both_SS_conf_attacked.AttackedID_2 = (Place*) LocalStateVariables[4];
  Both_SS_conf_attacked.Channel2_attacked = (Place*) LocalStateVariables[2];
  Both_Control_Conf_attacked.ControlAttack_in_progress = (Place*) LocalStateVariables[7];
  Both_Control_Conf_attacked.single_both_enabler = (Place*) LocalStateVariables[10];
  Both_Control_Conf_attacked.C_CH_1_attacked = (Place*) LocalStateVariables[8];
  Both_Control_Conf_attacked.C_CH_2_attacked = (Place*) LocalStateVariables[9];
}
void AdversarySAN::assignPlacesToActivitiesTimed(){
  Attacker_Profile_case1.Start = (Place*) LocalStateVariables[0];
  Attacker_Profile_case1.ConfAttack_in_progress = (Place*) LocalStateVariables[5];
  Attacker_Profile_case2.Start = (Place*) LocalStateVariables[0];
  Attacker_Profile_case2.Torque_Attack_in_progress = (Place*) LocalStateVariables[6];
  Attacker_Profile_case3.Start = (Place*) LocalStateVariables[0];
  Attacker_Profile_case3.ControlAttack_in_progress = (Place*) LocalStateVariables[7];
}
/*****************************************************************/
/*                  Activity Method Definitions                  */
/*****************************************************************/

/*======================SW_CH_SelectActivity_case1========================*/


AdversarySAN::SW_CH_SelectActivity_case1::SW_CH_SelectActivity_case1(){
  ActivityInitialize("SW_CH_Select_case1",1,Instantaneous , RaceEnabled, 3,2, false);
}

void AdversarySAN::SW_CH_SelectActivity_case1::LinkVariables(){
  ConfAttack_in_progress->Register(&ConfAttack_in_progress_Mobius_Mark);
  single_both_enabler->Register(&single_both_enabler_Mobius_Mark);
  Channel1_attacked->Register(&Channel1_attacked_Mobius_Mark);
  AttackedID_1->Register(&AttackedID_1_Mobius_Mark);
}

bool AdversarySAN::SW_CH_SelectActivity_case1::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(ConfAttack_in_progress_Mobius_Mark)) >=1)&&((single_both_enabler->Mark() == 0)));
  return NewEnabled;
}

double AdversarySAN::SW_CH_SelectActivity_case1::Weight(){ 
  return 0.5;
}

bool AdversarySAN::SW_CH_SelectActivity_case1::ReactivationPredicate(){ 
  return false;
}

bool AdversarySAN::SW_CH_SelectActivity_case1::ReactivationFunction(){ 
  return false;
}

double AdversarySAN::SW_CH_SelectActivity_case1::SampleDistribution(){
  return 0;
}

double* AdversarySAN::SW_CH_SelectActivity_case1::ReturnDistributionParameters(){
    return NULL;
}

int AdversarySAN::SW_CH_SelectActivity_case1::Rank(){
  return 1;
}

BaseActionClass* AdversarySAN::SW_CH_SelectActivity_case1::Fire(){
  ;
  (*(ConfAttack_in_progress_Mobius_Mark))--;
  AttackedID_1->Mark()=1;
  (*(Channel1_attacked_Mobius_Mark))++;
  return this;
}

/*======================SW_CH_SelectActivity_case2========================*/


AdversarySAN::SW_CH_SelectActivity_case2::SW_CH_SelectActivity_case2(){
  ActivityInitialize("SW_CH_Select_case2",1,Instantaneous , RaceEnabled, 3,2, false);
}

void AdversarySAN::SW_CH_SelectActivity_case2::LinkVariables(){
  ConfAttack_in_progress->Register(&ConfAttack_in_progress_Mobius_Mark);
  single_both_enabler->Register(&single_both_enabler_Mobius_Mark);
  Channel2_attacked->Register(&Channel2_attacked_Mobius_Mark);
  AttackedID_2->Register(&AttackedID_2_Mobius_Mark);
}

bool AdversarySAN::SW_CH_SelectActivity_case2::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(ConfAttack_in_progress_Mobius_Mark)) >=1)&&((single_both_enabler->Mark() == 0)));
  return NewEnabled;
}

double AdversarySAN::SW_CH_SelectActivity_case2::Weight(){ 
  return 0.5;
}

bool AdversarySAN::SW_CH_SelectActivity_case2::ReactivationPredicate(){ 
  return false;
}

bool AdversarySAN::SW_CH_SelectActivity_case2::ReactivationFunction(){ 
  return false;
}

double AdversarySAN::SW_CH_SelectActivity_case2::SampleDistribution(){
  return 0;
}

double* AdversarySAN::SW_CH_SelectActivity_case2::ReturnDistributionParameters(){
    return NULL;
}

int AdversarySAN::SW_CH_SelectActivity_case2::Rank(){
  return 1;
}

BaseActionClass* AdversarySAN::SW_CH_SelectActivity_case2::Fire(){
  ;
  (*(ConfAttack_in_progress_Mobius_Mark))--;
  AttackedID_2->Mark()=2;
  (*(Channel2_attacked_Mobius_Mark))++;
  return this;
}

/*======================C_CH_SelectActivity_case1========================*/


AdversarySAN::C_CH_SelectActivity_case1::C_CH_SelectActivity_case1(){
  ActivityInitialize("C_CH_Select_case1",2,Instantaneous , RaceEnabled, 2,2, false);
}

void AdversarySAN::C_CH_SelectActivity_case1::LinkVariables(){
  ControlAttack_in_progress->Register(&ControlAttack_in_progress_Mobius_Mark);
  single_both_enabler->Register(&single_both_enabler_Mobius_Mark);
  C_CH_1_attacked->Register(&C_CH_1_attacked_Mobius_Mark);
}

bool AdversarySAN::C_CH_SelectActivity_case1::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(ControlAttack_in_progress_Mobius_Mark)) >=1)&&((single_both_enabler->Mark() == 0)));
  return NewEnabled;
}

double AdversarySAN::C_CH_SelectActivity_case1::Weight(){ 
  return 0.5;
}

bool AdversarySAN::C_CH_SelectActivity_case1::ReactivationPredicate(){ 
  return false;
}

bool AdversarySAN::C_CH_SelectActivity_case1::ReactivationFunction(){ 
  return false;
}

double AdversarySAN::C_CH_SelectActivity_case1::SampleDistribution(){
  return 0;
}

double* AdversarySAN::C_CH_SelectActivity_case1::ReturnDistributionParameters(){
    return NULL;
}

int AdversarySAN::C_CH_SelectActivity_case1::Rank(){
  return 1;
}

BaseActionClass* AdversarySAN::C_CH_SelectActivity_case1::Fire(){
  ;
  (*(ControlAttack_in_progress_Mobius_Mark))--;
  (*(C_CH_1_attacked_Mobius_Mark))++;
  return this;
}

/*======================C_CH_SelectActivity_case2========================*/


AdversarySAN::C_CH_SelectActivity_case2::C_CH_SelectActivity_case2(){
  ActivityInitialize("C_CH_Select_case2",2,Instantaneous , RaceEnabled, 2,2, false);
}

void AdversarySAN::C_CH_SelectActivity_case2::LinkVariables(){
  ControlAttack_in_progress->Register(&ControlAttack_in_progress_Mobius_Mark);
  single_both_enabler->Register(&single_both_enabler_Mobius_Mark);
  C_CH_2_attacked->Register(&C_CH_2_attacked_Mobius_Mark);
}

bool AdversarySAN::C_CH_SelectActivity_case2::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(ControlAttack_in_progress_Mobius_Mark)) >=1)&&((single_both_enabler->Mark() == 0)));
  return NewEnabled;
}

double AdversarySAN::C_CH_SelectActivity_case2::Weight(){ 
  return 0.5;
}

bool AdversarySAN::C_CH_SelectActivity_case2::ReactivationPredicate(){ 
  return false;
}

bool AdversarySAN::C_CH_SelectActivity_case2::ReactivationFunction(){ 
  return false;
}

double AdversarySAN::C_CH_SelectActivity_case2::SampleDistribution(){
  return 0;
}

double* AdversarySAN::C_CH_SelectActivity_case2::ReturnDistributionParameters(){
    return NULL;
}

int AdversarySAN::C_CH_SelectActivity_case2::Rank(){
  return 1;
}

BaseActionClass* AdversarySAN::C_CH_SelectActivity_case2::Fire(){
  ;
  (*(ControlAttack_in_progress_Mobius_Mark))--;
  (*(C_CH_2_attacked_Mobius_Mark))++;
  return this;
}

/*======================Both_SS_conf_attackedActivity========================*/


AdversarySAN::Both_SS_conf_attackedActivity::Both_SS_conf_attackedActivity(){
  ActivityInitialize("Both_SS_conf_attacked",3,Instantaneous , RaceEnabled, 5,2, false);
}

void AdversarySAN::Both_SS_conf_attackedActivity::LinkVariables(){
  ConfAttack_in_progress->Register(&ConfAttack_in_progress_Mobius_Mark);
  single_both_enabler->Register(&single_both_enabler_Mobius_Mark);
  AttackedID_1->Register(&AttackedID_1_Mobius_Mark);
  Channel1_attacked->Register(&Channel1_attacked_Mobius_Mark);
  AttackedID_2->Register(&AttackedID_2_Mobius_Mark);
  Channel2_attacked->Register(&Channel2_attacked_Mobius_Mark);
}

bool AdversarySAN::Both_SS_conf_attackedActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(ConfAttack_in_progress_Mobius_Mark)) >=1)&&((single_both_enabler->Mark() > 0)));
  return NewEnabled;
}

double AdversarySAN::Both_SS_conf_attackedActivity::Weight(){ 
  return 1;
}

bool AdversarySAN::Both_SS_conf_attackedActivity::ReactivationPredicate(){ 
  return false;
}

bool AdversarySAN::Both_SS_conf_attackedActivity::ReactivationFunction(){ 
  return false;
}

double AdversarySAN::Both_SS_conf_attackedActivity::SampleDistribution(){
  return 0;
}

double* AdversarySAN::Both_SS_conf_attackedActivity::ReturnDistributionParameters(){
    return NULL;
}

int AdversarySAN::Both_SS_conf_attackedActivity::Rank(){
  return 1;
}

BaseActionClass* AdversarySAN::Both_SS_conf_attackedActivity::Fire(){
  ;
  (*(ConfAttack_in_progress_Mobius_Mark))--;
  AttackedID_1->Mark()=1;
Channel1_attacked->Mark()=1;
AttackedID_2->Mark()=2;
Channel2_attacked->Mark()=1;
  return this;
}

/*======================Both_Control_Conf_attackedActivity========================*/


AdversarySAN::Both_Control_Conf_attackedActivity::Both_Control_Conf_attackedActivity(){
  ActivityInitialize("Both_Control_Conf_attacked",4,Instantaneous , RaceEnabled, 3,2, false);
}

void AdversarySAN::Both_Control_Conf_attackedActivity::LinkVariables(){
  ControlAttack_in_progress->Register(&ControlAttack_in_progress_Mobius_Mark);
  single_both_enabler->Register(&single_both_enabler_Mobius_Mark);
  C_CH_1_attacked->Register(&C_CH_1_attacked_Mobius_Mark);
  C_CH_2_attacked->Register(&C_CH_2_attacked_Mobius_Mark);
}

bool AdversarySAN::Both_Control_Conf_attackedActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(ControlAttack_in_progress_Mobius_Mark)) >=1)&&((single_both_enabler->Mark() > 0)));
  return NewEnabled;
}

double AdversarySAN::Both_Control_Conf_attackedActivity::Weight(){ 
  return 1;
}

bool AdversarySAN::Both_Control_Conf_attackedActivity::ReactivationPredicate(){ 
  return false;
}

bool AdversarySAN::Both_Control_Conf_attackedActivity::ReactivationFunction(){ 
  return false;
}

double AdversarySAN::Both_Control_Conf_attackedActivity::SampleDistribution(){
  return 0;
}

double* AdversarySAN::Both_Control_Conf_attackedActivity::ReturnDistributionParameters(){
    return NULL;
}

int AdversarySAN::Both_Control_Conf_attackedActivity::Rank(){
  return 1;
}

BaseActionClass* AdversarySAN::Both_Control_Conf_attackedActivity::Fire(){
  ;
  (*(ControlAttack_in_progress_Mobius_Mark))--;
  C_CH_1_attacked->Mark()=1;
C_CH_2_attacked->Mark()=1;

  return this;
}

/*======================Attacker_ProfileActivity_case1========================*/

AdversarySAN::Attacker_ProfileActivity_case1::Attacker_ProfileActivity_case1(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("Attacker_Profile_case1",0,Exponential, RaceEnabled, 2,1, false);
}

AdversarySAN::Attacker_ProfileActivity_case1::~Attacker_ProfileActivity_case1(){
  delete[] TheDistributionParameters;
}

void AdversarySAN::Attacker_ProfileActivity_case1::LinkVariables(){
  Start->Register(&Start_Mobius_Mark);
  ConfAttack_in_progress->Register(&ConfAttack_in_progress_Mobius_Mark);
}

bool AdversarySAN::Attacker_ProfileActivity_case1::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(Start_Mobius_Mark)) >=1));
  return NewEnabled;
}

double AdversarySAN::Attacker_ProfileActivity_case1::Rate(){
  return AttackRate;
  return 1.0;  // default rate if none is specified
}

double AdversarySAN::Attacker_ProfileActivity_case1::Weight(){ 
  return SS_Conf_Attack;
}

bool AdversarySAN::Attacker_ProfileActivity_case1::ReactivationPredicate(){ 
  return false;
}

bool AdversarySAN::Attacker_ProfileActivity_case1::ReactivationFunction(){ 
  return false;
}

double AdversarySAN::Attacker_ProfileActivity_case1::SampleDistribution(){
  return TheDistribution->Exponential(AttackRate);
}

double* AdversarySAN::Attacker_ProfileActivity_case1::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int AdversarySAN::Attacker_ProfileActivity_case1::Rank(){
  return 1;
}

BaseActionClass* AdversarySAN::Attacker_ProfileActivity_case1::Fire(){
  (*(Start_Mobius_Mark))--;
  (*(ConfAttack_in_progress_Mobius_Mark))++;
  return this;
}

/*======================Attacker_ProfileActivity_case2========================*/

AdversarySAN::Attacker_ProfileActivity_case2::Attacker_ProfileActivity_case2(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("Attacker_Profile_case2",0,Exponential, RaceEnabled, 2,1, false);
}

AdversarySAN::Attacker_ProfileActivity_case2::~Attacker_ProfileActivity_case2(){
  delete[] TheDistributionParameters;
}

void AdversarySAN::Attacker_ProfileActivity_case2::LinkVariables(){
  Start->Register(&Start_Mobius_Mark);
  Torque_Attack_in_progress->Register(&Torque_Attack_in_progress_Mobius_Mark);
}

bool AdversarySAN::Attacker_ProfileActivity_case2::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(Start_Mobius_Mark)) >=1));
  return NewEnabled;
}

double AdversarySAN::Attacker_ProfileActivity_case2::Rate(){
  return AttackRate;
  return 1.0;  // default rate if none is specified
}

double AdversarySAN::Attacker_ProfileActivity_case2::Weight(){ 
  return TorqueAttack;
}

bool AdversarySAN::Attacker_ProfileActivity_case2::ReactivationPredicate(){ 
  return false;
}

bool AdversarySAN::Attacker_ProfileActivity_case2::ReactivationFunction(){ 
  return false;
}

double AdversarySAN::Attacker_ProfileActivity_case2::SampleDistribution(){
  return TheDistribution->Exponential(AttackRate);
}

double* AdversarySAN::Attacker_ProfileActivity_case2::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int AdversarySAN::Attacker_ProfileActivity_case2::Rank(){
  return 1;
}

BaseActionClass* AdversarySAN::Attacker_ProfileActivity_case2::Fire(){
  (*(Start_Mobius_Mark))--;
  (*(Torque_Attack_in_progress_Mobius_Mark))++;
  return this;
}

/*======================Attacker_ProfileActivity_case3========================*/

AdversarySAN::Attacker_ProfileActivity_case3::Attacker_ProfileActivity_case3(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("Attacker_Profile_case3",0,Exponential, RaceEnabled, 2,1, false);
}

AdversarySAN::Attacker_ProfileActivity_case3::~Attacker_ProfileActivity_case3(){
  delete[] TheDistributionParameters;
}

void AdversarySAN::Attacker_ProfileActivity_case3::LinkVariables(){
  Start->Register(&Start_Mobius_Mark);
  ControlAttack_in_progress->Register(&ControlAttack_in_progress_Mobius_Mark);
}

bool AdversarySAN::Attacker_ProfileActivity_case3::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(Start_Mobius_Mark)) >=1));
  return NewEnabled;
}

double AdversarySAN::Attacker_ProfileActivity_case3::Rate(){
  return AttackRate;
  return 1.0;  // default rate if none is specified
}

double AdversarySAN::Attacker_ProfileActivity_case3::Weight(){ 
  return ControlConfAttack;
}

bool AdversarySAN::Attacker_ProfileActivity_case3::ReactivationPredicate(){ 
  return false;
}

bool AdversarySAN::Attacker_ProfileActivity_case3::ReactivationFunction(){ 
  return false;
}

double AdversarySAN::Attacker_ProfileActivity_case3::SampleDistribution(){
  return TheDistribution->Exponential(AttackRate);
}

double* AdversarySAN::Attacker_ProfileActivity_case3::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int AdversarySAN::Attacker_ProfileActivity_case3::Rank(){
  return 1;
}

BaseActionClass* AdversarySAN::Attacker_ProfileActivity_case3::Fire(){
  (*(Start_Mobius_Mark))--;
  (*(ControlAttack_in_progress_Mobius_Mark))++;
  return this;
}

