#ifndef AdversarySAN_H_
#define AdversarySAN_H_

#include "Cpp/BaseClasses/EmptyGroup.h"
#include "Cpp/BaseClasses/PreselectGroup.h"
#include "Cpp/BaseClasses/PostselectGroup.h"
#include "Cpp/BaseClasses/state/StructStateVariable.h"
#include "Cpp/BaseClasses/state/ArrayStateVariable.h"
#include "Cpp/BaseClasses/SAN/SANModel.h" 
#include "Cpp/BaseClasses/SAN/Place.h"
#include "Cpp/BaseClasses/SAN/ExtendedPlace.h"
extern double AttackRate;
extern double SS_Conf_Attack;
extern double TorqueAttack;
extern double ControlConfAttack;
extern short attack_count;
extern short single_SS_enabler_is_0;
extern UserDistributions* TheDistribution;

void MemoryError();


/*********************************************************************
               AdversarySAN Submodel Definition                   
*********************************************************************/

class AdversarySAN:public SANModel{
public:

class SW_CH_SelectActivity_case1:public Activity {
public:

  Place* ConfAttack_in_progress;
  short* ConfAttack_in_progress_Mobius_Mark;
  Place* single_both_enabler;
  short* single_both_enabler_Mobius_Mark;
  Place* Channel1_attacked;
  short* Channel1_attacked_Mobius_Mark;
  Place* AttackedID_1;
  short* AttackedID_1_Mobius_Mark;

  double* TheDistributionParameters;
  SW_CH_SelectActivity_case1();
  double Rate(){return 0;}
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
}; // SW_CH_SelectActivity_case1Activity

class SW_CH_SelectActivity_case2:public Activity {
public:

  Place* ConfAttack_in_progress;
  short* ConfAttack_in_progress_Mobius_Mark;
  Place* single_both_enabler;
  short* single_both_enabler_Mobius_Mark;
  Place* Channel2_attacked;
  short* Channel2_attacked_Mobius_Mark;
  Place* AttackedID_2;
  short* AttackedID_2_Mobius_Mark;

  double* TheDistributionParameters;
  SW_CH_SelectActivity_case2();
  double Rate(){return 0;}
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
}; // SW_CH_SelectActivity_case2Activity

class C_CH_SelectActivity_case1:public Activity {
public:

  Place* ControlAttack_in_progress;
  short* ControlAttack_in_progress_Mobius_Mark;
  Place* single_both_enabler;
  short* single_both_enabler_Mobius_Mark;
  Place* C_CH_1_attacked;
  short* C_CH_1_attacked_Mobius_Mark;

  double* TheDistributionParameters;
  C_CH_SelectActivity_case1();
  double Rate(){return 0;}
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
}; // C_CH_SelectActivity_case1Activity

class C_CH_SelectActivity_case2:public Activity {
public:

  Place* ControlAttack_in_progress;
  short* ControlAttack_in_progress_Mobius_Mark;
  Place* single_both_enabler;
  short* single_both_enabler_Mobius_Mark;
  Place* C_CH_2_attacked;
  short* C_CH_2_attacked_Mobius_Mark;

  double* TheDistributionParameters;
  C_CH_SelectActivity_case2();
  double Rate(){return 0;}
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
}; // C_CH_SelectActivity_case2Activity

class Both_SS_conf_attackedActivity:public Activity {
public:

  Place* ConfAttack_in_progress;
  short* ConfAttack_in_progress_Mobius_Mark;
  Place* single_both_enabler;
  short* single_both_enabler_Mobius_Mark;
  Place* AttackedID_1;
  short* AttackedID_1_Mobius_Mark;
  Place* Channel1_attacked;
  short* Channel1_attacked_Mobius_Mark;
  Place* AttackedID_2;
  short* AttackedID_2_Mobius_Mark;
  Place* Channel2_attacked;
  short* Channel2_attacked_Mobius_Mark;

  double* TheDistributionParameters;
  Both_SS_conf_attackedActivity();
  double Rate(){return 0;}
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
}; // Both_SS_conf_attackedActivityActivity

class Both_Control_Conf_attackedActivity:public Activity {
public:

  Place* ControlAttack_in_progress;
  short* ControlAttack_in_progress_Mobius_Mark;
  Place* single_both_enabler;
  short* single_both_enabler_Mobius_Mark;
  Place* C_CH_1_attacked;
  short* C_CH_1_attacked_Mobius_Mark;
  Place* C_CH_2_attacked;
  short* C_CH_2_attacked_Mobius_Mark;

  double* TheDistributionParameters;
  Both_Control_Conf_attackedActivity();
  double Rate(){return 0;}
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
}; // Both_Control_Conf_attackedActivityActivity

class Attacker_ProfileActivity_case1:public Activity {
public:

  Place* Start;
  short* Start_Mobius_Mark;
  Place* ConfAttack_in_progress;
  short* ConfAttack_in_progress_Mobius_Mark;

  double* TheDistributionParameters;
  Attacker_ProfileActivity_case1();
  ~Attacker_ProfileActivity_case1();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // Attacker_ProfileActivity_case1Activity

class Attacker_ProfileActivity_case2:public Activity {
public:

  Place* Start;
  short* Start_Mobius_Mark;
  Place* Torque_Attack_in_progress;
  short* Torque_Attack_in_progress_Mobius_Mark;

  double* TheDistributionParameters;
  Attacker_ProfileActivity_case2();
  ~Attacker_ProfileActivity_case2();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // Attacker_ProfileActivity_case2Activity

class Attacker_ProfileActivity_case3:public Activity {
public:

  Place* Start;
  short* Start_Mobius_Mark;
  Place* ControlAttack_in_progress;
  short* ControlAttack_in_progress_Mobius_Mark;

  double* TheDistributionParameters;
  Attacker_ProfileActivity_case3();
  ~Attacker_ProfileActivity_case3();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // Attacker_ProfileActivity_case3Activity

  //List of user-specified place names
  Place* Start;
  Place* Channel1_attacked;
  Place* Channel2_attacked;
  Place* AttackedID_1;
  Place* AttackedID_2;
  Place* ConfAttack_in_progress;
  Place* Torque_Attack_in_progress;
  Place* ControlAttack_in_progress;
  Place* C_CH_1_attacked;
  Place* C_CH_2_attacked;
  Place* single_both_enabler;

  // Create instances of all actvities
  SW_CH_SelectActivity_case1 SW_CH_Select_case1;
  SW_CH_SelectActivity_case2 SW_CH_Select_case2;
  C_CH_SelectActivity_case1 C_CH_Select_case1;
  C_CH_SelectActivity_case2 C_CH_Select_case2;
  Both_SS_conf_attackedActivity Both_SS_conf_attacked;
  Both_Control_Conf_attackedActivity Both_Control_Conf_attacked;
  Attacker_ProfileActivity_case1 Attacker_Profile_case1;
  Attacker_ProfileActivity_case2 Attacker_Profile_case2;
  Attacker_ProfileActivity_case3 Attacker_Profile_case3;
  //Create instances of all groups 
  PreselectGroup ImmediateGroup;
  PostselectGroup SW_CH_SelectGroup;
  PostselectGroup C_CH_SelectGroup;
  PostselectGroup Both_SS_conf_attackedGroup;
  PostselectGroup Both_Control_Conf_attackedGroup;
  PostselectGroup Attacker_ProfileGroup;
  AdversarySAN();
  ~AdversarySAN();
  void CustomInitialization();

  void assignPlacesToActivitiesInst();
  void assignPlacesToActivitiesTimed();
}; // end AdversarySAN

#endif // AdversarySAN_H_
