

// This C++ file was created by SanEditor

#include "Atomic/Control_configuration_channel/Control_configuration_channelSAN.h"

#include <stdlib.h>
#include <iostream>

#include <math.h>


/*****************************************************************
                         Control_configuration_channelSAN Constructor             
******************************************************************/


Control_configuration_channelSAN::Control_configuration_channelSAN(){


  Correct_incorrectGroup.initialize(2, "Correct_incorrectGroup");
  Correct_incorrectGroup.appendGroup((BaseGroupClass*) &Correct_incorrect_case1);
  Correct_incorrectGroup.appendGroup((BaseGroupClass*) &Correct_incorrect_case2);

  Repair_control_confGroup.initialize(2, "Repair_control_confGroup");
  Repair_control_confGroup.appendGroup((BaseGroupClass*) &Repair_control_conf_case1);
  Repair_control_confGroup.appendGroup((BaseGroupClass*) &Repair_control_conf_case2);

  Detection_windowGroup.initialize(2, "Detection_windowGroup");
  Detection_windowGroup.appendGroup((BaseGroupClass*) &Detection_window_case1);
  Detection_windowGroup.appendGroup((BaseGroupClass*) &Detection_window_case2);

  Activity* InitialActionList[6]={
    &Correct_incorrect_case1, //0
    &Correct_incorrect_case2, //1
    &Repair_control_conf_case1, //2
    &Repair_control_conf_case2, //3
    &Detection_window_case1, //4
    &Detection_window_case2  // 5
  };

  BaseGroupClass* InitialGroupList[3]={
    (BaseGroupClass*) &(Correct_incorrectGroup), 
    (BaseGroupClass*) &(Repair_control_confGroup), 
    (BaseGroupClass*) &(Detection_windowGroup)
  };

  Attack_in_progress = new Place("Attack_in_progress" ,0);
  Correct_Control = new Place("Correct_Control" ,1);
  Incorrect_Control = new Place("Incorrect_Control" ,0);
  Unsafe_state_2 = new Place("Unsafe_state_2" ,0);
  OK_state = new Place("OK_state" ,1);
  Safe_failure = new Place("Safe_failure" ,0);
  Configuration_state = new Place("Configuration_state" ,1);
  BaseStateVariableClass* InitialPlaces[7]={
    Attack_in_progress,  // 0
    Correct_Control,  // 1
    Incorrect_Control,  // 2
    Unsafe_state_2,  // 3
    OK_state,  // 4
    Safe_failure,  // 5
    Configuration_state   // 6
  };
  BaseStateVariableClass* InitialROPlaces[0]={
  };
  initializeSANModelNow("Control_configuration_channel", 7, InitialPlaces, 
                        0, InitialROPlaces, 
                        6, InitialActionList, 3, InitialGroupList);


  assignPlacesToActivitiesInst();
  assignPlacesToActivitiesTimed();

  int AffectArcs[21][2]={ 
    {0,0}, {1,0}, {0,1}, {1,1}, {2,1}, {2,2}, {5,2}, {4,2}, {1,2}, 
    {2,3}, {2,4}, {6,4}, {3,4}, {4,4}, {5,4}, {1,4}, {2,5}, {3,5}, 
    {4,5}, {5,5}, {1,5}
  };
  for(int n=0;n<21;n++) {
    AddAffectArc(InitialPlaces[AffectArcs[n][0]],
                 InitialActionList[AffectArcs[n][1]]);
  }
  int EnableArcs[16][2]={ 
    {0,0}, {1,0}, {4,0}, {5,0}, {0,1}, {1,1}, {4,1}, {5,1}, {2,2}, 
    {4,2}, {5,2}, {2,3}, {4,3}, {5,3}, {2,4}, {2,5}
  };
  for(int n=0;n<16;n++) {
    AddEnableArc(InitialPlaces[EnableArcs[n][0]],
                 InitialActionList[EnableArcs[n][1]]);
  }

  for(int n=0;n<6;n++) {
    InitialActionList[n]->LinkVariables();
  }
  CustomInitialization();

}

void Control_configuration_channelSAN::CustomInitialization() {

}
Control_configuration_channelSAN::~Control_configuration_channelSAN(){
  for (int i = 0; i < NumStateVariables-NumReadOnlyPlaces; i++)
    delete LocalStateVariables[i];
};

void Control_configuration_channelSAN::assignPlacesToActivitiesInst(){
}
void Control_configuration_channelSAN::assignPlacesToActivitiesTimed(){
  Correct_incorrect_case1.Attack_in_progress = (Place*) LocalStateVariables[0];
  Correct_incorrect_case1.Correct_Control = (Place*) LocalStateVariables[1];
  Correct_incorrect_case1.OK_state = (Place*) LocalStateVariables[4];
  Correct_incorrect_case1.Safe_failure = (Place*) LocalStateVariables[5];
  Correct_incorrect_case2.Attack_in_progress = (Place*) LocalStateVariables[0];
  Correct_incorrect_case2.Correct_Control = (Place*) LocalStateVariables[1];
  Correct_incorrect_case2.OK_state = (Place*) LocalStateVariables[4];
  Correct_incorrect_case2.Safe_failure = (Place*) LocalStateVariables[5];
  Correct_incorrect_case2.Incorrect_Control = (Place*) LocalStateVariables[2];
  Repair_control_conf_case1.Incorrect_Control = (Place*) LocalStateVariables[2];
  Repair_control_conf_case1.OK_state = (Place*) LocalStateVariables[4];
  Repair_control_conf_case1.Safe_failure = (Place*) LocalStateVariables[5];
  Repair_control_conf_case1.Correct_Control = (Place*) LocalStateVariables[1];
  Repair_control_conf_case2.Incorrect_Control = (Place*) LocalStateVariables[2];
  Repair_control_conf_case2.OK_state = (Place*) LocalStateVariables[4];
  Repair_control_conf_case2.Safe_failure = (Place*) LocalStateVariables[5];
  Detection_window_case1.Incorrect_Control = (Place*) LocalStateVariables[2];
  Detection_window_case1.Configuration_state = (Place*) LocalStateVariables[6];
  Detection_window_case1.Unsafe_state_2 = (Place*) LocalStateVariables[3];
  Detection_window_case1.OK_state = (Place*) LocalStateVariables[4];
  Detection_window_case1.Safe_failure = (Place*) LocalStateVariables[5];
  Detection_window_case1.Correct_Control = (Place*) LocalStateVariables[1];
  Detection_window_case2.Incorrect_Control = (Place*) LocalStateVariables[2];
  Detection_window_case2.Unsafe_state_2 = (Place*) LocalStateVariables[3];
  Detection_window_case2.OK_state = (Place*) LocalStateVariables[4];
  Detection_window_case2.Safe_failure = (Place*) LocalStateVariables[5];
  Detection_window_case2.Correct_Control = (Place*) LocalStateVariables[1];
}
/*****************************************************************/
/*                  Activity Method Definitions                  */
/*****************************************************************/

/*======================Correct_incorrectActivity_case1========================*/

Control_configuration_channelSAN::Correct_incorrectActivity_case1::Correct_incorrectActivity_case1(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("Correct_incorrect_case1",0,Exponential, RaceEnabled, 2,4, false);
}

Control_configuration_channelSAN::Correct_incorrectActivity_case1::~Correct_incorrectActivity_case1(){
  delete[] TheDistributionParameters;
}

void Control_configuration_channelSAN::Correct_incorrectActivity_case1::LinkVariables(){
  Attack_in_progress->Register(&Attack_in_progress_Mobius_Mark);
  Correct_Control->Register(&Correct_Control_Mobius_Mark);
  OK_state->Register(&OK_state_Mobius_Mark);
  Safe_failure->Register(&Safe_failure_Mobius_Mark);
}

bool Control_configuration_channelSAN::Correct_incorrectActivity_case1::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(Attack_in_progress_Mobius_Mark)) >=1)&&((*(Correct_Control_Mobius_Mark)) >=1)&&(((OK_state->Mark() != 0) || (Safe_failure->Mark() != 0))));
  return NewEnabled;
}

double Control_configuration_channelSAN::Correct_incorrectActivity_case1::Rate(){
  return 2.77778E-07;
  return 1.0;  // default rate if none is specified
}

double Control_configuration_channelSAN::Correct_incorrectActivity_case1::Weight(){ 
  return((double)(1.0) - C_Att_Success);
}

bool Control_configuration_channelSAN::Correct_incorrectActivity_case1::ReactivationPredicate(){ 
  return false;
}

bool Control_configuration_channelSAN::Correct_incorrectActivity_case1::ReactivationFunction(){ 
  return false;
}

double Control_configuration_channelSAN::Correct_incorrectActivity_case1::SampleDistribution(){
  return TheDistribution->Exponential(2.77778E-07);
}

double* Control_configuration_channelSAN::Correct_incorrectActivity_case1::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int Control_configuration_channelSAN::Correct_incorrectActivity_case1::Rank(){
  return 1;
}

BaseActionClass* Control_configuration_channelSAN::Correct_incorrectActivity_case1::Fire(){
  ;
  (*(Attack_in_progress_Mobius_Mark))--;
  (*(Correct_Control_Mobius_Mark))--;
  (*(Correct_Control_Mobius_Mark))++;
  return this;
}

/*======================Correct_incorrectActivity_case2========================*/

Control_configuration_channelSAN::Correct_incorrectActivity_case2::Correct_incorrectActivity_case2(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("Correct_incorrect_case2",0,Exponential, RaceEnabled, 3,4, false);
}

Control_configuration_channelSAN::Correct_incorrectActivity_case2::~Correct_incorrectActivity_case2(){
  delete[] TheDistributionParameters;
}

void Control_configuration_channelSAN::Correct_incorrectActivity_case2::LinkVariables(){
  Attack_in_progress->Register(&Attack_in_progress_Mobius_Mark);
  Correct_Control->Register(&Correct_Control_Mobius_Mark);
  OK_state->Register(&OK_state_Mobius_Mark);
  Safe_failure->Register(&Safe_failure_Mobius_Mark);
  Incorrect_Control->Register(&Incorrect_Control_Mobius_Mark);
}

bool Control_configuration_channelSAN::Correct_incorrectActivity_case2::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(Attack_in_progress_Mobius_Mark)) >=1)&&((*(Correct_Control_Mobius_Mark)) >=1)&&(((OK_state->Mark() != 0) || (Safe_failure->Mark() != 0))));
  return NewEnabled;
}

double Control_configuration_channelSAN::Correct_incorrectActivity_case2::Rate(){
  return 2.77778E-07;
  return 1.0;  // default rate if none is specified
}

double Control_configuration_channelSAN::Correct_incorrectActivity_case2::Weight(){ 
  return(C_Att_Success);
}

bool Control_configuration_channelSAN::Correct_incorrectActivity_case2::ReactivationPredicate(){ 
  return false;
}

bool Control_configuration_channelSAN::Correct_incorrectActivity_case2::ReactivationFunction(){ 
  return false;
}

double Control_configuration_channelSAN::Correct_incorrectActivity_case2::SampleDistribution(){
  return TheDistribution->Exponential(2.77778E-07);
}

double* Control_configuration_channelSAN::Correct_incorrectActivity_case2::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int Control_configuration_channelSAN::Correct_incorrectActivity_case2::Rank(){
  return 1;
}

BaseActionClass* Control_configuration_channelSAN::Correct_incorrectActivity_case2::Fire(){
  ;
  (*(Attack_in_progress_Mobius_Mark))--;
  (*(Correct_Control_Mobius_Mark))--;
  (*(Incorrect_Control_Mobius_Mark))++;
  return this;
}

/*======================Repair_control_confActivity_case1========================*/

Control_configuration_channelSAN::Repair_control_confActivity_case1::Repair_control_confActivity_case1(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("Repair_control_conf_case1",1,Exponential, RaceEnabled, 4,3, false);
}

Control_configuration_channelSAN::Repair_control_confActivity_case1::~Repair_control_confActivity_case1(){
  delete[] TheDistributionParameters;
}

void Control_configuration_channelSAN::Repair_control_confActivity_case1::LinkVariables(){
  Incorrect_Control->Register(&Incorrect_Control_Mobius_Mark);
  OK_state->Register(&OK_state_Mobius_Mark);
  Safe_failure->Register(&Safe_failure_Mobius_Mark);
  Correct_Control->Register(&Correct_Control_Mobius_Mark);
}

bool Control_configuration_channelSAN::Repair_control_confActivity_case1::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(Incorrect_Control_Mobius_Mark)) >=1)&&(((OK_state->Mark() != 0) || (Safe_failure->Mark() != 0))));
  return NewEnabled;
}

double Control_configuration_channelSAN::Repair_control_confActivity_case1::Rate(){
  return 100;
  return 1.0;  // default rate if none is specified
}

double Control_configuration_channelSAN::Repair_control_confActivity_case1::Weight(){ 
  return((double)(1.0) - C_Rep_Success);
}

bool Control_configuration_channelSAN::Repair_control_confActivity_case1::ReactivationPredicate(){ 
  return false;
}

bool Control_configuration_channelSAN::Repair_control_confActivity_case1::ReactivationFunction(){ 
  return false;
}

double Control_configuration_channelSAN::Repair_control_confActivity_case1::SampleDistribution(){
  return TheDistribution->Exponential(100);
}

double* Control_configuration_channelSAN::Repair_control_confActivity_case1::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int Control_configuration_channelSAN::Repair_control_confActivity_case1::Rank(){
  return 1;
}

BaseActionClass* Control_configuration_channelSAN::Repair_control_confActivity_case1::Fire(){
  ;
  (*(Incorrect_Control_Mobius_Mark))--;
  if(Safe_failure->Mark() > 0)
{
  Safe_failure->Mark() = 0;
  OK_state->Mark() = 1;
// Unsafe_state_2->Mark() must be 0 and remains so.
}
Correct_Control->Mark() = 1;	// Always restore Correct_control.

  return this;
}

/*======================Repair_control_confActivity_case2========================*/

Control_configuration_channelSAN::Repair_control_confActivity_case2::Repair_control_confActivity_case2(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("Repair_control_conf_case2",1,Exponential, RaceEnabled, 1,3, false);
}

Control_configuration_channelSAN::Repair_control_confActivity_case2::~Repair_control_confActivity_case2(){
  delete[] TheDistributionParameters;
}

void Control_configuration_channelSAN::Repair_control_confActivity_case2::LinkVariables(){
  Incorrect_Control->Register(&Incorrect_Control_Mobius_Mark);
  OK_state->Register(&OK_state_Mobius_Mark);
  Safe_failure->Register(&Safe_failure_Mobius_Mark);
}

bool Control_configuration_channelSAN::Repair_control_confActivity_case2::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(Incorrect_Control_Mobius_Mark)) >=1)&&(((OK_state->Mark() != 0) || (Safe_failure->Mark() != 0))));
  return NewEnabled;
}

double Control_configuration_channelSAN::Repair_control_confActivity_case2::Rate(){
  return 100;
  return 1.0;  // default rate if none is specified
}

double Control_configuration_channelSAN::Repair_control_confActivity_case2::Weight(){ 
  return(C_Rep_Success);
}

bool Control_configuration_channelSAN::Repair_control_confActivity_case2::ReactivationPredicate(){ 
  return false;
}

bool Control_configuration_channelSAN::Repair_control_confActivity_case2::ReactivationFunction(){ 
  return false;
}

double Control_configuration_channelSAN::Repair_control_confActivity_case2::SampleDistribution(){
  return TheDistribution->Exponential(100);
}

double* Control_configuration_channelSAN::Repair_control_confActivity_case2::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int Control_configuration_channelSAN::Repair_control_confActivity_case2::Rank(){
  return 1;
}

BaseActionClass* Control_configuration_channelSAN::Repair_control_confActivity_case2::Fire(){
  ;
  (*(Incorrect_Control_Mobius_Mark))--;
  (*(Incorrect_Control_Mobius_Mark))++;
  return this;
}

/*======================Detection_windowActivity_case1========================*/

Control_configuration_channelSAN::Detection_windowActivity_case1::Detection_windowActivity_case1(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("Detection_window_case1",2,Deterministic, RaceEnabled, 6,1, false);
}

Control_configuration_channelSAN::Detection_windowActivity_case1::~Detection_windowActivity_case1(){
  delete[] TheDistributionParameters;
}

void Control_configuration_channelSAN::Detection_windowActivity_case1::LinkVariables(){
  Incorrect_Control->Register(&Incorrect_Control_Mobius_Mark);
  Configuration_state->Register(&Configuration_state_Mobius_Mark);
  Unsafe_state_2->Register(&Unsafe_state_2_Mobius_Mark);
  OK_state->Register(&OK_state_Mobius_Mark);
  Safe_failure->Register(&Safe_failure_Mobius_Mark);
  Correct_Control->Register(&Correct_Control_Mobius_Mark);
}

bool Control_configuration_channelSAN::Detection_windowActivity_case1::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(Incorrect_Control_Mobius_Mark)) >=1));
  return NewEnabled;
}

double Control_configuration_channelSAN::Detection_windowActivity_case1::DeterministicParamValue(){
  return 4.16667E-08

;
  return 1.0;  // default rate if none is specified
}

double Control_configuration_channelSAN::Detection_windowActivity_case1::Weight(){ 
  return(C_fail_det_prob);
}

bool Control_configuration_channelSAN::Detection_windowActivity_case1::ReactivationPredicate(){ 
  return false;
}

bool Control_configuration_channelSAN::Detection_windowActivity_case1::ReactivationFunction(){ 
  return false;
}

double Control_configuration_channelSAN::Detection_windowActivity_case1::SampleDistribution(){
  return 4.16667E-08

;
}

double* Control_configuration_channelSAN::Detection_windowActivity_case1::ReturnDistributionParameters(){
  TheDistributionParameters[0] = DeterministicParamValue();
  return TheDistributionParameters;
}

int Control_configuration_channelSAN::Detection_windowActivity_case1::Rank(){
  return 1;
}

BaseActionClass* Control_configuration_channelSAN::Detection_windowActivity_case1::Fire(){
  (*(Incorrect_Control_Mobius_Mark))--;
  if(Configuration_state->Mark() > 0)
  {
    Unsafe_state_2->Mark() = 0;
    OK_state->Mark() = 0;
    Safe_failure->Mark() = 1;
  }
else
  {
    Unsafe_state_2->Mark() = 1;
    OK_state->Mark() = 0;
    Safe_failure->Mark() = 0;
  }
// Now set Channel_OK to 0
Correct_Control->Mark() = 1;	
// The last statement is only here to allow for future attacks 
// if unsafe_2 is recovered from.
// Once Unsafe_state_2 is set to non-zero, 
// the future attackes will be blocked by the input gate, Attack_enabler. 
  return this;
}

/*======================Detection_windowActivity_case2========================*/

Control_configuration_channelSAN::Detection_windowActivity_case2::Detection_windowActivity_case2(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("Detection_window_case2",2,Deterministic, RaceEnabled, 5,1, false);
}

Control_configuration_channelSAN::Detection_windowActivity_case2::~Detection_windowActivity_case2(){
  delete[] TheDistributionParameters;
}

void Control_configuration_channelSAN::Detection_windowActivity_case2::LinkVariables(){
  Incorrect_Control->Register(&Incorrect_Control_Mobius_Mark);
  Unsafe_state_2->Register(&Unsafe_state_2_Mobius_Mark);
  OK_state->Register(&OK_state_Mobius_Mark);
  Safe_failure->Register(&Safe_failure_Mobius_Mark);
  Correct_Control->Register(&Correct_Control_Mobius_Mark);
}

bool Control_configuration_channelSAN::Detection_windowActivity_case2::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(Incorrect_Control_Mobius_Mark)) >=1));
  return NewEnabled;
}

double Control_configuration_channelSAN::Detection_windowActivity_case2::DeterministicParamValue(){
  return 4.16667E-08

;
  return 1.0;  // default rate if none is specified
}

double Control_configuration_channelSAN::Detection_windowActivity_case2::Weight(){ 
  return((double)(1.0) - C_fail_det_prob);
}

bool Control_configuration_channelSAN::Detection_windowActivity_case2::ReactivationPredicate(){ 
  return false;
}

bool Control_configuration_channelSAN::Detection_windowActivity_case2::ReactivationFunction(){ 
  return false;
}

double Control_configuration_channelSAN::Detection_windowActivity_case2::SampleDistribution(){
  return 4.16667E-08

;
}

double* Control_configuration_channelSAN::Detection_windowActivity_case2::ReturnDistributionParameters(){
  TheDistributionParameters[0] = DeterministicParamValue();
  return TheDistributionParameters;
}

int Control_configuration_channelSAN::Detection_windowActivity_case2::Rank(){
  return 1;
}

BaseActionClass* Control_configuration_channelSAN::Detection_windowActivity_case2::Fire(){
  (*(Incorrect_Control_Mobius_Mark))--;
  Unsafe_state_2->Mark() = 1;
OK_state->Mark() = 0;
Safe_failure->Mark() = 0;
Correct_Control->Mark() = 1;	
// The last statement is only here to allow for future attacks 
// if unsafe_2 is recovered from.
// Once Unsafe_state_2 is set to non-zero, 
// the future attackes will be blocked by the input gate, Attack_enabler. 
  return this;
}

