#ifndef configuration_channelSAN_H_
#define configuration_channelSAN_H_

#include "Cpp/BaseClasses/EmptyGroup.h"
#include "Cpp/BaseClasses/PreselectGroup.h"
#include "Cpp/BaseClasses/PostselectGroup.h"
#include "Cpp/BaseClasses/state/StructStateVariable.h"
#include "Cpp/BaseClasses/state/ArrayStateVariable.h"
#include "Cpp/BaseClasses/SAN/SANModel.h" 
#include "Cpp/BaseClasses/SAN/Place.h"
#include "Cpp/BaseClasses/SAN/ExtendedPlace.h"
extern double Configuration_validation_Duration;
extern double Config_repair_success;
extern double attack_CH1_success_pr;
extern double attack_CH2_success_pr;
extern UserDistributions* TheDistribution;

void MemoryError();


/*********************************************************************
               configuration_channelSAN Submodel Definition                   
*********************************************************************/

class configuration_channelSAN:public SANModel{
public:

class Correct_Incorrect_1Activity_case1:public Activity {
public:

  Place* Correct;
  short* Correct_Mobius_Mark;
  Place* Attack_in_progress;
  short* Attack_in_progress_Mobius_Mark;
  Place* Channel_attacked_ID;
  short* Channel_attacked_ID_Mobius_Mark;

  double* TheDistributionParameters;
  Correct_Incorrect_1Activity_case1();
  ~Correct_Incorrect_1Activity_case1();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // Correct_Incorrect_1Activity_case1Activity

class Correct_Incorrect_1Activity_case2:public Activity {
public:

  Place* Correct;
  short* Correct_Mobius_Mark;
  Place* Attack_in_progress;
  short* Attack_in_progress_Mobius_Mark;
  Place* Incorrect_2;
  short* Incorrect_2_Mobius_Mark;
  Place* Channel_attacked_ID;
  short* Channel_attacked_ID_Mobius_Mark;

  double* TheDistributionParameters;
  Correct_Incorrect_1Activity_case2();
  ~Correct_Incorrect_1Activity_case2();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // Correct_Incorrect_1Activity_case2Activity

class Correct_Incorrect_2Activity_case1:public Activity {
public:

  Place* Attack_in_progress;
  short* Attack_in_progress_Mobius_Mark;
  Place* Correct;
  short* Correct_Mobius_Mark;
  Place* Channel_attacked_ID;
  short* Channel_attacked_ID_Mobius_Mark;

  double* TheDistributionParameters;
  Correct_Incorrect_2Activity_case1();
  ~Correct_Incorrect_2Activity_case1();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // Correct_Incorrect_2Activity_case1Activity

class Correct_Incorrect_2Activity_case2:public Activity {
public:

  Place* Attack_in_progress;
  short* Attack_in_progress_Mobius_Mark;
  Place* Correct;
  short* Correct_Mobius_Mark;
  Place* Incorrect_1;
  short* Incorrect_1_Mobius_Mark;
  Place* Channel_attacked_ID;
  short* Channel_attacked_ID_Mobius_Mark;

  double* TheDistributionParameters;
  Correct_Incorrect_2Activity_case2();
  ~Correct_Incorrect_2Activity_case2();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // Correct_Incorrect_2Activity_case2Activity

class Incorrect_1_Incorrect_2Activity_case1:public Activity {
public:

  Place* Incorrect_1;
  short* Incorrect_1_Mobius_Mark;
  Place* Attack_in_progress;
  short* Attack_in_progress_Mobius_Mark;
  Place* Channel_attacked_ID;
  short* Channel_attacked_ID_Mobius_Mark;

  double* TheDistributionParameters;
  Incorrect_1_Incorrect_2Activity_case1();
  ~Incorrect_1_Incorrect_2Activity_case1();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // Incorrect_1_Incorrect_2Activity_case1Activity

class Incorrect_1_Incorrect_2Activity_case2:public Activity {
public:

  Place* Incorrect_1;
  short* Incorrect_1_Mobius_Mark;
  Place* Attack_in_progress;
  short* Attack_in_progress_Mobius_Mark;
  Place* Incorrect_2;
  short* Incorrect_2_Mobius_Mark;
  Place* Channel_attacked_ID;
  short* Channel_attacked_ID_Mobius_Mark;

  double* TheDistributionParameters;
  Incorrect_1_Incorrect_2Activity_case2();
  ~Incorrect_1_Incorrect_2Activity_case2();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // Incorrect_1_Incorrect_2Activity_case2Activity

class Incorrect_2_Incorrect_1Activity_case1:public Activity {
public:

  Place* Incorrect_2;
  short* Incorrect_2_Mobius_Mark;
  Place* Attack_in_progress;
  short* Attack_in_progress_Mobius_Mark;
  Place* Channel_attacked_ID;
  short* Channel_attacked_ID_Mobius_Mark;

  double* TheDistributionParameters;
  Incorrect_2_Incorrect_1Activity_case1();
  ~Incorrect_2_Incorrect_1Activity_case1();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // Incorrect_2_Incorrect_1Activity_case1Activity

class Incorrect_2_Incorrect_1Activity_case2:public Activity {
public:

  Place* Incorrect_2;
  short* Incorrect_2_Mobius_Mark;
  Place* Attack_in_progress;
  short* Attack_in_progress_Mobius_Mark;
  Place* Incorrect_1;
  short* Incorrect_1_Mobius_Mark;
  Place* Channel_attacked_ID;
  short* Channel_attacked_ID_Mobius_Mark;

  double* TheDistributionParameters;
  Incorrect_2_Incorrect_1Activity_case2();
  ~Incorrect_2_Incorrect_1Activity_case2();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // Incorrect_2_Incorrect_1Activity_case2Activity

class Restore_Conf_1Activity_case1:public Activity {
public:

  Place* Incorrect_1;
  short* Incorrect_1_Mobius_Mark;
  Place* Correct;
  short* Correct_Mobius_Mark;
  Place* Attack_in_progress;
  short* Attack_in_progress_Mobius_Mark;
  Place* Channel_attacked_ID;
  short* Channel_attacked_ID_Mobius_Mark;

  double* TheDistributionParameters;
  Restore_Conf_1Activity_case1();
  ~Restore_Conf_1Activity_case1();
  double Rate(){return 0;}
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double DeterministicParamValue();
}; // Restore_Conf_1Activity_case1Activity

class Restore_Conf_1Activity_case2:public Activity {
public:

  Place* Incorrect_1;
  short* Incorrect_1_Mobius_Mark;

  double* TheDistributionParameters;
  Restore_Conf_1Activity_case2();
  ~Restore_Conf_1Activity_case2();
  double Rate(){return 0;}
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double DeterministicParamValue();
}; // Restore_Conf_1Activity_case2Activity

class Restore_Conf_2Activity_case1:public Activity {
public:

  Place* Incorrect_2;
  short* Incorrect_2_Mobius_Mark;
  Place* Correct;
  short* Correct_Mobius_Mark;
  Place* Attack_in_progress;
  short* Attack_in_progress_Mobius_Mark;
  Place* Channel_attacked_ID;
  short* Channel_attacked_ID_Mobius_Mark;

  double* TheDistributionParameters;
  Restore_Conf_2Activity_case1();
  ~Restore_Conf_2Activity_case1();
  double Rate(){return 0;}
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double DeterministicParamValue();
}; // Restore_Conf_2Activity_case1Activity

class Restore_Conf_2Activity_case2:public Activity {
public:

  Place* Incorrect_2;
  short* Incorrect_2_Mobius_Mark;

  double* TheDistributionParameters;
  Restore_Conf_2Activity_case2();
  ~Restore_Conf_2Activity_case2();
  double Rate(){return 0;}
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double DeterministicParamValue();
}; // Restore_Conf_2Activity_case2Activity

  //List of user-specified place names
  Place* Correct;
  Place* Incorrect_2;
  Place* Incorrect_1;
  Place* Attack_in_progress;
  Place* Channel_attacked_ID;

  // Create instances of all actvities
  Correct_Incorrect_1Activity_case1 Correct_Incorrect_1_case1;
  Correct_Incorrect_1Activity_case2 Correct_Incorrect_1_case2;
  Correct_Incorrect_2Activity_case1 Correct_Incorrect_2_case1;
  Correct_Incorrect_2Activity_case2 Correct_Incorrect_2_case2;
  Incorrect_1_Incorrect_2Activity_case1 Incorrect_1_Incorrect_2_case1;
  Incorrect_1_Incorrect_2Activity_case2 Incorrect_1_Incorrect_2_case2;
  Incorrect_2_Incorrect_1Activity_case1 Incorrect_2_Incorrect_1_case1;
  Incorrect_2_Incorrect_1Activity_case2 Incorrect_2_Incorrect_1_case2;
  Restore_Conf_1Activity_case1 Restore_Conf_1_case1;
  Restore_Conf_1Activity_case2 Restore_Conf_1_case2;
  Restore_Conf_2Activity_case1 Restore_Conf_2_case1;
  Restore_Conf_2Activity_case2 Restore_Conf_2_case2;
  //Create instances of all groups 
  EmptyGroup ImmediateGroup;
  PostselectGroup Correct_Incorrect_1Group;  PostselectGroup Correct_Incorrect_2Group;  PostselectGroup Incorrect_1_Incorrect_2Group;  PostselectGroup Incorrect_2_Incorrect_1Group;  PostselectGroup Restore_Conf_1Group;  PostselectGroup Restore_Conf_2Group;
  configuration_channelSAN();
  ~configuration_channelSAN();
  void CustomInitialization();

  void assignPlacesToActivitiesInst();
  void assignPlacesToActivitiesTimed();
}; // end configuration_channelSAN

#endif // configuration_channelSAN_H_
