#include "MTT_emotorPVModel.h"

MTT_emotorPVModel::MTT_emotorPVModel(bool expandTimeArrays) {
  TheModel=new Div_SWRJ();
  DefineName("MTT_emotorPVModel");
  StateMode = 1;
  CreatePVList(10, expandTimeArrays);
  Initialize();
}



PerformanceVariableNode* MTT_emotorPVModel::createPVNode(int pvindex, int timeindex) {
  switch(pvindex) {
  case 0:
    return new MTT_emotorPV0(timeindex);
    break;
  case 1:
    return new MTT_emotorPV1(timeindex);
    break;
  case 2:
    return new MTT_emotorPV2(timeindex);
    break;
  case 3:
    return new MTT_emotorPV3(timeindex);
    break;
  case 4:
    return new MTT_emotorPV4(timeindex);
    break;
  case 5:
    return new MTT_emotorPV5(timeindex);
    break;
  case 6:
    return new MTT_emotorPV6(timeindex);
    break;
  case 7:
    return new MTT_emotorPV7(timeindex);
    break;
  case 8:
    return new MTT_emotorPV8(timeindex);
    break;
  case 9:
    return new MTT_emotorPV9(timeindex);
    break;
  }
  return NULL;
}
