#ifndef _MTT_EMOTOR_PVS_
#define _MTT_EMOTOR_PVS_
#include <math.h>
#include "Cpp/Performance_Variables/PerformanceVariableNode.hpp"
#include "Composed/Div_SW/Div_SWRJ__Channel_1.h"
#include "Composed/Div_SW/Div_SWRJ__Channel_2.h"
#include "Composed/Div_SW/Div_SWRJ.h"
#include "Cpp/Performance_Variables/IntervalOfTime.hpp"
#include "Cpp/Performance_Variables/IntervalOfTimeImpulse.hpp"
#include "Cpp/Performance_Variables/InstantOfTime.hpp"


class MTT_emotorPV0Worker:public IntervalOfTime
{
 public:
  AdjudicatorSAN *Adjudicator;
  
  MTT_emotorPV0Worker();
  ~MTT_emotorPV0Worker();
  double Reward_Function();
};

class MTT_emotorPV0:public PerformanceVariableNode
{
 public:
  Div_SWRJ *TheDiv_SWRJ;

  MTT_emotorPV0Worker *MTT_emotorPV0WorkerList;

  MTT_emotorPV0(int timeindex=0);
  ~MTT_emotorPV0();
  void CreateWorkerList(void);
};

class MTT_emotorPV1Worker:public IntervalOfTime
{
 public:
  AdjudicatorSAN *Adjudicator;
  
  MTT_emotorPV1Worker();
  ~MTT_emotorPV1Worker();
  double Reward_Function();
};

class MTT_emotorPV1:public PerformanceVariableNode
{
 public:
  Div_SWRJ *TheDiv_SWRJ;

  MTT_emotorPV1Worker *MTT_emotorPV1WorkerList;

  MTT_emotorPV1(int timeindex=0);
  ~MTT_emotorPV1();
  void CreateWorkerList(void);
};


class MTT_emotorPV2Impulse0:public IntervalOfTimeImpulse
{
 public:
  AdjudicatorSAN *Adjudicator;

  MTT_emotorPV2Impulse0();
  ~MTT_emotorPV2Impulse0();
  double Impulse_Function(double);
  ImpulseNodeClass** CreateImpulseWorkerList(int);
 private:
  ImpulseNodeClass** ImpulseWorkerList;
  int ImpulseWorkerListLength;
};

class MTT_emotorPV2:public PerformanceVariableNode
{
 public:
  Div_SWRJ *TheDiv_SWRJ;

  MTT_emotorPV2Impulse0 Impulse0;

  MTT_emotorPV2(int timeindex=0);
  ~MTT_emotorPV2();
  void CreateWorkerList(void);
};

class MTT_emotorPV3Worker:public IntervalOfTime
{
 public:
  AdjudicatorSAN *Adjudicator;
  
  MTT_emotorPV3Worker();
  ~MTT_emotorPV3Worker();
  double Reward_Function();
};

class MTT_emotorPV3:public PerformanceVariableNode
{
 public:
  Div_SWRJ *TheDiv_SWRJ;

  MTT_emotorPV3Worker *MTT_emotorPV3WorkerList;

  MTT_emotorPV3(int timeindex=0);
  ~MTT_emotorPV3();
  void CreateWorkerList(void);
};

class MTT_emotorPV4Worker:public IntervalOfTime
{
 public:
  AdjudicatorSAN *Adjudicator;
  
  MTT_emotorPV4Worker();
  ~MTT_emotorPV4Worker();
  double Reward_Function();
};

class MTT_emotorPV4:public PerformanceVariableNode
{
 public:
  Div_SWRJ *TheDiv_SWRJ;

  MTT_emotorPV4Worker *MTT_emotorPV4WorkerList;

  MTT_emotorPV4(int timeindex=0);
  ~MTT_emotorPV4();
  void CreateWorkerList(void);
};

class MTT_emotorPV5Worker:public InstantOfTime
{
 public:
  AdjudicatorSAN *Adjudicator;
  
  MTT_emotorPV5Worker();
  ~MTT_emotorPV5Worker();
  double Reward_Function();
};

class MTT_emotorPV5:public PerformanceVariableNode
{
 public:
  Div_SWRJ *TheDiv_SWRJ;

  MTT_emotorPV5Worker *MTT_emotorPV5WorkerList;

  MTT_emotorPV5(int timeindex=0);
  ~MTT_emotorPV5();
  void CreateWorkerList(void);
};

class MTT_emotorPV6Worker:public InstantOfTime
{
 public:
  AdjudicatorSAN *Adjudicator;
  
  MTT_emotorPV6Worker();
  ~MTT_emotorPV6Worker();
  double Reward_Function();
};

class MTT_emotorPV6:public PerformanceVariableNode
{
 public:
  Div_SWRJ *TheDiv_SWRJ;

  MTT_emotorPV6Worker *MTT_emotorPV6WorkerList;

  MTT_emotorPV6(int timeindex=0);
  ~MTT_emotorPV6();
  void CreateWorkerList(void);
};

class MTT_emotorPV7Worker:public InstantOfTime
{
 public:
  AdjudicatorSAN *Adjudicator;
  
  MTT_emotorPV7Worker();
  ~MTT_emotorPV7Worker();
  double Reward_Function();
};

class MTT_emotorPV7:public PerformanceVariableNode
{
 public:
  Div_SWRJ *TheDiv_SWRJ;

  MTT_emotorPV7Worker *MTT_emotorPV7WorkerList;

  MTT_emotorPV7(int timeindex=0);
  ~MTT_emotorPV7();
  void CreateWorkerList(void);
};

class MTT_emotorPV8Worker:public InstantOfTime
{
 public:
  T_Conf_channelSAN *T_Conf_channel;
  
  MTT_emotorPV8Worker();
  ~MTT_emotorPV8Worker();
  double Reward_Function();
};

class MTT_emotorPV8:public PerformanceVariableNode
{
 public:
  Div_SWRJ *TheDiv_SWRJ;

  MTT_emotorPV8Worker *MTT_emotorPV8WorkerList;

  MTT_emotorPV8(int timeindex=0);
  ~MTT_emotorPV8();
  void CreateWorkerList(void);
};

class MTT_emotorPV9Worker:public InstantOfTime
{
 public:
  T_Conf_channelSAN *T_Conf_channel;
  
  MTT_emotorPV9Worker();
  ~MTT_emotorPV9Worker();
  double Reward_Function();
};

class MTT_emotorPV9:public PerformanceVariableNode
{
 public:
  Div_SWRJ *TheDiv_SWRJ;

  MTT_emotorPV9Worker *MTT_emotorPV9WorkerList;

  MTT_emotorPV9(int timeindex=0);
  ~MTT_emotorPV9();
  void CreateWorkerList(void);
};

#endif
